// Copyright 2025 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE SCHEMA DEFINITION AND DESCRIPTION IN
//   ../../../../../src/3rdparty/chromium/components/search_engines/prepopulated_engines_schema.json
//   ../../../../../src/3rdparty/chromium/components/search_engines/prepopulated_engines.json
// DO NOT EDIT.

#include "prepopulated_engines.h"

namespace TemplateURLPrepopulateData {

const int kMaxPrepopulatedEngineID = 112;
const int kCurrentDataVersion = 146;

const PrepopulatedEngine ask = {
  u"Ask",
  u"ask.com",
  "https://www.ask.com/wp-content/uploads/sites/3/2021/10/ask-favicon.png",
  "https://www.ask.com/web?q={searchTerms}",
  "UTF-8",
  "https://lss.sse-iacapps.com/query?q={searchTerms}&li=ff",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_ASK,
  NULL,
  NULL,
  4,
};

const char* const array_baidu_alternate_urls[] = {
  "https://www.baidu.com/s?ie={inputEncoding}&wd={searchTerms}",
  "https://www.baidu.com/s?ie={inputEncoding}&word={searchTerms}",
  "https://www.baidu.com/{google:pathWildcard}/s?ie={inputEncoding}&word={searchTerms}",
};
const PrepopulatedEngine baidu = {
  u"\x767e" u"\x5ea6" u"",
  u"baidu.com",
  "https://www.baidu.com/favicon.ico",
  "https://www.baidu.com/#ie={inputEncoding}&wd={searchTerms}",
  "UTF-8",
  "https://suggestion.baidu.com/su?wd={searchTerms}&action=opensearch&ie={inputEncoding}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_baidu_alternate_urls,
  3,
  SEARCH_ENGINE_BAIDU,
  NULL,
  NULL,
  21,
};

const PrepopulatedEngine bing = {
  u"Bing",
  u"bing.com",
  "https://www.bing.com/sa/simg/bing_p_rr_teal_min.ico",
  "https://www.bing.com/search?q={searchTerms}&PC=U316&FORM=CHROMN",
  "UTF-8",
  "https://www.bing.com/osjson.aspx?query={searchTerms}&language={language}&PC=U316",
  "https://www.bing.com/images/detail/search?iss=sbiupload&FORM=CHROMI#enterInsights",
  NULL,
  "https://www.bing.com/chrome/newtab",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  "imageBin={google:imageThumbnailBase64}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_BING,
  NULL,
  NULL,
  3,
};

const PrepopulatedEngine brave = {
  u"Brave Search",
  u"search.brave.com",
  "https://cdn.search.brave.com/serp/favicon.ico",
  "https://search.brave.com/search?q={searchTerms}",
  "UTF-8",
  "https://search.brave.com/api/suggest?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_BRAVE,
  NULL,
  NULL,
  109,
};

const PrepopulatedEngine coccoc = {
  u"C\x1ed1" u"c C\x1ed1" u"c",
  u"coccoc.com",
  "https://coccoc.com/favicon.ico",
  "https://coccoc.com/search#query={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_COCCOC,
  NULL,
  NULL,
  91,
};

const PrepopulatedEngine daum = {
  u"Daum",
  u"daum.net",
  "https://search.daum.net/favicon.ico",
  "https://search.daum.net/search?w=tot&DA=JU5&q={searchTerms}",
  "UTF-8",
  "https://suggest.search.daum.net/sushi/opensearch/pc?q={searchTerms}&DA=JU6",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_DAUM,
  NULL,
  NULL,
  68,
};

const PrepopulatedEngine duckduckgo = {
  u"DuckDuckGo",
  u"duckduckgo.com",
  "https://duckduckgo.com/favicon.ico",
  "https://duckduckgo.com/?q={searchTerms}",
  "UTF-8",
  "https://duckduckgo.com/ac/?q={searchTerms}&type=list",
  NULL,
  NULL,
  "https://duckduckgo.com/chrome_newtab",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_DUCKDUCKGO,
  NULL,
  NULL,
  92,
};

const PrepopulatedEngine ecosia = {
  u"Ecosia",
  u"ecosia.org",
  "https://cdn.ecosia.org/assets/images/ico/favicon.ico",
  "https://www.ecosia.org/search?q={searchTerms}&addon=opensearch",
  "UTF-8",
  "https://ac.ecosia.org/autocomplete?q={searchTerms}&type=list",
  "https://www.ecosia.org/images?q={searchTerms}&addon=opensearch",
  NULL,
  "https://www.ecosia.org/newtab/",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_ECOSIA,
  NULL,
  NULL,
  101,
};

const char* const array_google_alternate_urls[] = {
  "{google:baseURL}#q={searchTerms}",
  "{google:baseURL}search#q={searchTerms}",
  "{google:baseURL}webhp#q={searchTerms}",
  "{google:baseURL}s#q={searchTerms}",
  "{google:baseURL}s?q={searchTerms}",
};
const char* const array_google_search_intent_params[] = {
  "si",
  "gs_ssp",
};
const PrepopulatedEngine google = {
  u"Google",
  u"google.com",
  "https://www.google.com/images/branding/product/ico/googleg_alldp.ico",
  "{google:baseURL}search?q={searchTerms}&{google:RLZ}{google:originalQueryForSuggestion}{google:assistedQueryStats}{google:searchFieldtrialParameter}{google:iOSSearchLanguage}{google:prefetchSource}{google:searchClient}{google:sourceId}{google:contextualSearchVersion}ie={inputEncoding}",
  "UTF-8",
  "{google:baseSuggestURL}search?{google:searchFieldtrialParameter}client={google:suggestClient}&gs_ri={google:suggestRid}&xssi=t&q={searchTerms}&{google:inputType}{google:omniboxFocusType}{google:cursorPosition}{google:currentPageUrl}{google:pageClassification}{google:clientCacheTimeToLive}{google:searchVersion}{google:sessionToken}{google:prefetchQuery}sugkey={google:suggestAPIKeyParameter}",
  "{google:baseSearchByImageURL}upload",
  "{google:baseSearchByImageURL}upload?filtertype=tr&{imageTranslateSourceLocale}{imageTranslateTargetLocale}",
  NULL,
  "{google:baseURL}_/contextualsearch?{google:contextualSearchVersion}{google:contextualSearchContextData}",
  NULL,
  NULL,
  NULL,
  NULL,
  "encoded_image={google:imageThumbnail},image_url={google:imageURL},sbisrc={google:imageSearchSource},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},processed_image_dimensions={google:processedImageDimensions}",
  "sidesearch",
  "sideimagesearch",
  "sourcelang",
  "targetlang",
  NULL,
  array_google_search_intent_params,
  2,
  array_google_alternate_urls,
  5,
  SEARCH_ENGINE_GOOGLE,
  "ALLOWED",
  "ALLOWED",
  1,
};

const PrepopulatedEngine karma = {
  u"Karma Search",
  u"karmasearch.org",
  "https://karmasearch.org/favicon.ico",
  "https://karmasearch.org/search?q={searchTerms}",
  "UTF-8",
  "https://api.karmasearch.org/search/autosuggest?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_KARMA,
  NULL,
  NULL,
  110,
};

const PrepopulatedEngine lilo = {
  u"Lilo",
  u"lilo.org",
  "https://www.lilo.org/wp-content/themes/jarvis_wp/ajans/assets/favicon.ico",
  "https://search.lilo.org/?q={searchTerms}",
  "UTF-8",
  "https://search.lilo.org/api/?service=suggestions&action=suggest&q={searchTerms}&f=chr&l={language}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_OTHER,
  NULL,
  NULL,
  111,
};

const char* const array_mail_ru_alternate_urls[] = {
  "https://go.mail.ru/msearch?q={searchTerms}&{mailru:referralID}",
};
const PrepopulatedEngine mail_ru = {
  u"@MAIL.RU",
  u"mail.ru",
  "https://go.imgsmail.ru/favicon.ico",
  "https://go.mail.ru/search?q={searchTerms}&{mailru:referralID}&fr=ch_omnibox",
  "UTF-8",
  "https://suggests.go.mail.ru/chrome?q={searchTerms}",
  NULL,
  NULL,
  "https://go.mail.ru/chrome/newtab/",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_mail_ru_alternate_urls,
  1,
  SEARCH_ENGINE_MAILRU,
  NULL,
  NULL,
  83,
};

const PrepopulatedEngine mojeek = {
  u"Mojeek",
  u"mojeek.com",
  "https://www.mojeek.com/favicon.ico",
  "https://www.mojeek.com/search?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_MOJEEK,
  NULL,
  NULL,
  103,
};

const PrepopulatedEngine naver = {
  u"\xb124" u"\xc774" u"\xbc84" u"",
  u"naver.com",
  "https://ssl.pstatic.net/sstatic/search/favicon/favicon_140327.ico",
  "https://search.naver.com/search.naver?ie={inputEncoding}&query={searchTerms}&sm=chr_hty",
  "UTF-8",
  "https://ac.search.naver.com/nx/ac?of=os&ie={inputEncoding}&q={searchTerms}&oe={outputEncoding}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_NAVER,
  NULL,
  NULL,
  67,
};

const PrepopulatedEngine nona = {
  u"Nona",
  u"nona.de",
  "https://www.nona.de/favicon.ico",
  "https://www.nona.de/?q={searchTerms}",
  "UTF-8",
  "https://www.nona.de/autocomplete/?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_NONA,
  NULL,
  NULL,
  107,
};

const PrepopulatedEngine panda = {
  u"WWF Panda Search",
  u"panda-search.org",
  "https://panda-search.org/favicon.ico",
  "https://panda-search.org/search/?q={searchTerms}",
  "UTF-8",
  "https://suggest.panda-search.org/suggest?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_PANDASEARCH,
  NULL,
  NULL,
  104,
};

const PrepopulatedEngine petal_search = {
  u"Petal Search",
  u"petalsearch.com",
  "https://search-static-dre.dbankcdn.com/pc/v1/favicon.ico",
  "https://petalsearch.com/search?query={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_PETALSEARCH,
  NULL,
  NULL,
  102,
};

const PrepopulatedEngine presearch = {
  u"Presearch",
  u"presearch.com",
  "https://presearch.com/favicon.ico",
  "https://presearch.com/search?q={searchTerms}&src=c",
  "UTF-8",
  "https://presearch.com/api/suggest?q={searchTerms}&src=c",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_PRESEARCH,
  NULL,
  NULL,
  105,
};

const PrepopulatedEngine quendu = {
  u"Quendu.com",
  u"quendu.com",
  "https://quendu.com/assets/favicon-48x48.png",
  "https://www.quendu.com/search?q={searchTerms}",
  "UTF-8",
  "https://www.quendu.com/suggest?query={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_QUENDU,
  NULL,
  NULL,
  108,
};

const PrepopulatedEngine qwant = {
  u"Qwant",
  u"qwant.com",
  "https://www.qwant.com/favicon.ico",
  "https://www.qwant.com/?q={searchTerms}&client=opensearch",
  "UTF-8",
  "https://api.qwant.com/api/suggest/?q={searchTerms}&client=opensearch",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_QWANT,
  NULL,
  NULL,
  94,
};

const PrepopulatedEngine seznam_cz = {
  u"Seznam",
  u"seznam.cz",
  "https://search.seznam.cz/favicon.ico",
  "https://search.seznam.cz/?q={searchTerms}",
  "UTF-8",
  "https://suggest.seznam.cz/fulltext_ff?phrase={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_SEZNAM,
  NULL,
  NULL,
  25,
};

const PrepopulatedEngine seznam_sk = {
  u"Seznam",
  u"seznam.sk",
  "https://search.seznam.sk/favicon.ico",
  "https://search.seznam.sk/?q={searchTerms}",
  "UTF-8",
  "https://suggest.seznam.sk/fulltext_ff?phrase={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_SEZNAM,
  NULL,
  NULL,
  25,
};

const char* const array_so_360_alternate_urls[] = {
  "https://m.so.com/s?ie={inputEncoding}&q={searchTerms}",
  "https://m.so.com/index.php?ie={inputEncoding}&q={searchTerms}",
};
const PrepopulatedEngine so_360 = {
  u"360",
  u"so.com",
  "https://www.so.com/favicon.ico",
  "https://www.so.com/s?ie={inputEncoding}&q={searchTerms}",
  "UTF-8",
  "https://sug.so.360.cn/suggest?encodein={inputEncoding}&encodeout={outputEncoding}&format=opensearch&word={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_so_360_alternate_urls,
  2,
  SEARCH_ENGINE_360,
  NULL,
  NULL,
  88,
};

const char* const array_sogou_alternate_urls[] = {
  "https://m.sogou.com/web/{google:pathWildcard}?ie={inputEncoding}&keyword={searchTerms}",
};
const PrepopulatedEngine sogou = {
  u"\x641c" u"\x72d7" u"",
  u"sogou.com",
  "https://www.sogou.com/images/logo/old/favicon.ico",
  "https://www.sogou.com/web?ie={inputEncoding}&query={searchTerms}",
  "UTF-8",
  "https://sugg.sogou.com/sugg/ajaj_json.jsp?type=addrbar&key={searchTerms}&ie={inputEncoding}&from=google",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_sogou_alternate_urls,
  1,
  SEARCH_ENGINE_SOGOU,
  NULL,
  NULL,
  56,
};

const PrepopulatedEngine yahoo = {
  u"Yahoo!",
  u"yahoo.com",
  "https://search.yahoo.com/favicon.ico",
  "https://search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas_sfp&p={searchTerms}",
  "UTF-8",
  "https://search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas_sfp&command={searchTerms}",
  NULL,
  NULL,
  "https://search.yahoo.com?fr=crmas_sfp",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_ar = {
  u"Yahoo! Argentina",
  u"ar.yahoo.com",
  "https://ar.search.yahoo.com/favicon.ico",
  "https://ar.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://ar.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_at = {
  u"Yahoo! \x00d6" u"sterreich",
  u"at.yahoo.com",
  "https://at.search.yahoo.com/favicon.ico",
  "https://at.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://at.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_au = {
  u"Yahoo!7",
  u"au.yahoo.com",
  "https://au.search.yahoo.com/favicon.ico",
  "https://au.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://au.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_br = {
  u"Yahoo! Brasil",
  u"br.yahoo.com",
  "https://br.search.yahoo.com/favicon.ico",
  "https://br.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://br.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_ca = {
  u"Yahoo! Canada",
  u"ca.yahoo.com",
  "https://ca.search.yahoo.com/favicon.ico",
  "https://ca.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://ca.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_ch = {
  u"Yahoo! Schweiz",
  u"ch.yahoo.com",
  "https://ch.search.yahoo.com/favicon.ico",
  "https://ch.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://ch.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_cl = {
  u"Yahoo! Chile",
  u"cl.yahoo.com",
  "https://cl.search.yahoo.com/favicon.ico",
  "https://cl.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://cl.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_co = {
  u"Yahoo! Colombia",
  u"co.yahoo.com",
  "https://co.search.yahoo.com/favicon.ico",
  "https://co.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://co.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_de = {
  u"Yahoo! Deutschland",
  u"de.yahoo.com",
  "https://de.search.yahoo.com/favicon.ico",
  "https://de.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://de.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_dk = {
  u"Yahoo! Danmark",
  u"dk.yahoo.com",
  "https://dk.search.yahoo.com/favicon.ico",
  "https://dk.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_es = {
  u"Yahoo! Espa\x00f1" u"a",
  u"es.yahoo.com",
  "https://es.search.yahoo.com/favicon.ico",
  "https://es.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://es.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_fi = {
  u"Yahoo! Suomi",
  u"fi.yahoo.com",
  "https://fi.search.yahoo.com/favicon.ico",
  "https://fi.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_fr = {
  u"Yahoo! France",
  u"fr.yahoo.com",
  "https://fr.search.yahoo.com/favicon.ico",
  "https://fr.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://fr.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_hk = {
  u"Yahoo! Hong Kong",
  u"hk.yahoo.com",
  "https://hk.search.yahoo.com/favicon.ico",
  "https://hk.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://hk.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_id = {
  u"Yahoo! Indonesia",
  u"id.yahoo.com",
  "https://id.search.yahoo.com/favicon.ico",
  "https://id.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://id.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_in = {
  u"Yahoo! India",
  u"in.yahoo.com",
  "https://in.search.yahoo.com/favicon.ico",
  "https://in.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://in.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_it = {
  u"Yahoo! Italia",
  u"it.yahoo.com",
  "https://it.search.yahoo.com/favicon.ico",
  "https://it.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://it.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_jp = {
  u"Yahoo! JAPAN",
  u"yahoo.co.jp",
  "https://search.yahoo.co.jp/favicon.ico",
  "https://search.yahoo.co.jp/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://search.yahooapis.jp/AssistSearchService/V2/webassistSearch?p={searchTerms}&appid=oQsoxcyxg66enp0TYoirkKoryq6rF8bK76mW0KYxZ0v0WPLtn.Lix6wy8F_LwGWHUII-&output=fxjson&fr=crmas",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_mx = {
  u"Yahoo! M\x00e9" u"xico",
  u"mx.yahoo.com",
  "https://mx.search.yahoo.com/favicon.ico",
  "https://mx.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://mx.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_my = {
  u"Yahoo! Malaysia",
  u"malaysia.yahoo.com",
  "https://malaysia.search.yahoo.com/favicon.ico",
  "https://malaysia.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://malaysia.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_nl = {
  u"Yahoo! Nederland",
  u"nl.yahoo.com",
  "https://nl.search.yahoo.com/favicon.ico",
  "https://nl.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://nl.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_nz = {
  u"Yahoo! New Zealand",
  u"nz.yahoo.com",
  "https://nz.search.yahoo.com/favicon.ico",
  "https://nz.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://nz.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_pe = {
  u"Yahoo! Per\x00fa" u"",
  u"pe.yahoo.com",
  "https://pe.search.yahoo.com/favicon.ico",
  "https://pe.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://pe.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_ph = {
  u"Yahoo! Philippines",
  u"ph.yahoo.com",
  "https://ph.search.yahoo.com/favicon.ico",
  "https://ph.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://ph.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_se = {
  u"Yahoo! Sverige",
  u"se.yahoo.com",
  "https://se.search.yahoo.com/favicon.ico",
  "https://se.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_sg = {
  u"Yahoo! Singapore",
  u"sg.yahoo.com",
  "https://sg.search.yahoo.com/favicon.ico",
  "https://sg.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://sg.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_th = {
  u"Yahoo! \x0e1b" u"\x0e23" u"\x0e30" u"\x0e40" u"\x0e17" u"\x0e28" u"\x0e44" u"\x0e17" u"\x0e22" u"",
  u"th.yahoo.com",
  "https://th.search.yahoo.com/favicon.ico",
  "https://th.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://th.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_tr = {
  u"Yahoo! T\x00fc" u"rkiye",
  u"tr.yahoo.com",
  "https://tr.search.yahoo.com/favicon.ico",
  "https://tr.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_tw = {
  u"Yahoo!\x5947" u"\x6469" u"",
  u"tw.yahoo.com",
  "https://tw.search.yahoo.com/favicon.ico",
  "https://tw.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://tw.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_uk = {
  u"Yahoo! UK & Ireland",
  u"uk.yahoo.com",
  "https://uk.search.yahoo.com/favicon.ico",
  "https://uk.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://uk.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_ve = {
  u"Yahoo! Venezuela",
  u"ve.yahoo.com",
  "https://ve.search.yahoo.com/favicon.ico",
  "https://ve.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://ve.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yahoo_vn = {
  u"Yahoo! Vi\x1ec7" u"t Nam",
  u"vn.yahoo.com",
  "https://vn.search.yahoo.com/favicon.ico",
  "https://vn.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://vn.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const PrepopulatedEngine yandex_by = {
  u"\x042f" u"\x043d" u"\x0434" u"\x0435" u"\x043a" u"\x0441" u"",
  u"yandex.by",
  "https://yastatic.net/lego/_/pDu9OWAQKB0s2J9IojKpiS_Eho.ico",
  "https://yandex.by/{yandex:searchPath}?text={searchTerms}",
  "UTF-8",
  "https://suggest.yandex.by/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}",
  "https://yandex.by/images/search/?rpt=imageview",
  NULL,
  "https://www.yandex.by/chrome/newtab",
  NULL,
  "https://storage.ape.yandex.net/get/browser/Doodles/yandex/drawable-xxhdpi/yandex.png",
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yandex_com = {
  u"Yandex",
  u"yandex.com",
  "https://yastatic.net/lego/_/rBTjd6UOPk5913OSn5ZQVYMTQWQ.ico",
  "https://yandex.com/search/?text={searchTerms}&from=os&clid=1836588",
  "UTF-8",
  "https://suggest.yandex.com/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}&uil=en&v=3&sn=5",
  "https://yandex.com/images/search?rpt=imageview",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yandex_kz = {
  u"\x042f" u"\x043d" u"\x0434" u"\x0435" u"\x043a" u"\x0441" u"",
  u"yandex.kz",
  "https://yastatic.net/lego/_/pDu9OWAQKB0s2J9IojKpiS_Eho.ico",
  "https://yandex.kz/{yandex:searchPath}?text={searchTerms}",
  "UTF-8",
  "https://suggest.yandex.kz/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}",
  "https://yandex.kz/images/search/?rpt=imageview",
  NULL,
  "https://www.yandex.kz/chrome/newtab",
  NULL,
  "https://storage.ape.yandex.net/get/browser/Doodles/yandex/drawable-xxhdpi/yandex.png",
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yandex_ru = {
  u"\x042f" u"\x043d" u"\x0434" u"\x0435" u"\x043a" u"\x0441" u"",
  u"yandex.ru",
  "https://yastatic.net/lego/_/pDu9OWAQKB0s2J9IojKpiS_Eho.ico",
  "https://yandex.ru/{yandex:searchPath}?text={searchTerms}&{yandex:referralID}",
  "UTF-8",
  "https://suggest.yandex.ru/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}",
  "https://yandex.ru/images/search/?rpt=imageview",
  NULL,
  "https://www.yandex.ru/chrome/newtab",
  NULL,
  "https://storage.ape.yandex.net/get/browser/Doodles/yandex/drawable-xxhdpi/yandex.png",
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yandex_tr = {
  u"Yandex",
  u"yandex.com.tr",
  "https://yastatic.net/lego/_/rBTjd6UOPk5913OSn5ZQVYMTQWQ.ico",
  "https://www.yandex.com.tr/{yandex:searchPath}?text={searchTerms}",
  "UTF-8",
  "https://suggest.yandex.com.tr/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}",
  "https://yandex.com.tr/gorsel/search?rpt=imageview",
  NULL,
  "https://www.yandex.com.tr/chrome/newtab",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yandex_ua = {
  u"\x042f" u"\x043d" u"\x0434" u"\x0435" u"\x043a" u"\x0441" u"",
  u"yandex.ua",
  "https://yastatic.net/lego/_/pDu9OWAQKB0s2J9IojKpiS_Eho.ico",
  "https://yandex.ua/{yandex:searchPath}?text={searchTerms}",
  "UTF-8",
  "https://suggest.yandex.ua/suggest-ff.cgi?part={searchTerms}&{google:cursorPosition}",
  "https://yandex.ua/images/search/?rpt=imageview",
  NULL,
  "https://www.yandex.ua/chrome/newtab",
  NULL,
  "https://storage.ape.yandex.net/get/browser/Doodles/yandex/drawable-xxhdpi/yandex.png",
  NULL,
  NULL,
  NULL,
  "upfile={google:imageThumbnail},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight},prg=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YANDEX,
  NULL,
  NULL,
  15,
};

const PrepopulatedEngine yep = {
  u"Yep",
  u"yep.com",
  "https://cdn.yep.com/static/meta/favicon.ico",
  "https://yep.com/web?q={searchTerms}",
  "UTF-8",
  "https://api.yep.com/ac/?query={searchTerms}&os=true",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YEP,
  NULL,
  NULL,
  106,
};

const PrepopulatedEngine you = {
  u"You.com",
  u"you.com",
  "https://api.you.com/favicon.ico",
  "https://you.com/search?tbm=youchat&q={searchTerms}",
  "UTF-8",
  "https://you.com/api/ac?domain=default&q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YOU,
  NULL,
  NULL,
  112,
};

const char* const array_atlas_cz_alternate_urls[] = {
  "http://searchatlas.centrum.cz/?q={searchTerms}",
};
const PrepopulatedEngine atlas_cz = {
  u"Atlas.cz",
  u"atlas.cz",
  "https://searchatlas.centrum.cz/favicon.ico",
  "https://searchatlas.centrum.cz/?q={searchTerms}",
  "UTF-8",
  "http://radce.centrum.cz/?q={searchTerms}&of=1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_atlas_cz_alternate_urls,
  1,
  SEARCH_ENGINE_ATLAS,
  NULL,
  NULL,
  27,
};

const char* const array_atlas_sk_alternate_urls[] = {
  "http://hladaj.atlas.sk/fulltext/?phrase={searchTerms}",
};
const PrepopulatedEngine atlas_sk = {
  u"ATLAS.SK",
  u"atlas.sk",
  "http://static.mediacentrum.sk/katalog/atlas.sk/images/favicon.ico",
  "https://hladaj.atlas.sk/fulltext/?phrase={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_atlas_sk_alternate_urls,
  1,
  SEARCH_ENGINE_ATLAS,
  NULL,
  NULL,
  27,
};

const char* const array_avg_alternate_urls[] = {
  "http://isearch.avg.com/search?q={searchTerms}",
  "http://search.avg.com/route/?q={searchTerms}&lng={language}",
  "https://isearch.avg.com/search?q={searchTerms}",
  "https://search.avg.com/route/?q={searchTerms}&lng={language}",
};
const PrepopulatedEngine avg = {
  u"AVG",
  u"search.avg.com",
  "http://search.avg.com/favicon.ico",
  "http://search.avg.com/search?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_avg_alternate_urls,
  4,
  SEARCH_ENGINE_AVG,
  NULL,
  NULL,
  50,
};

const char* const array_babylon_alternate_urls[] = {
  "http://search.babylon.com/?q={searchTerms}",
};
const PrepopulatedEngine babylon = {
  u"Babylon",
  u"search.babylon.com",
  "http://search.babylon.com/favicon.ico",
  "http://search.babylon.com/home?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_babylon_alternate_urls,
  1,
  SEARCH_ENGINE_BABYLON,
  NULL,
  NULL,
  64,
};

const char* const array_conduit_alternate_urls[] = {
  "http://search.conduit.com/Results.aspx?q={searchTerms}",
};
const PrepopulatedEngine conduit = {
  u"Conduit",
  u"conduit.com",
  "http://www.conduit.com/favicon.ico",
  "http://www.conduit.com/search?q={searchTerms}&ie={inputEncoding}&cx=010301873083402539744%3Anxaq5wgrtuo&cof=forid%3A11",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_conduit_alternate_urls,
  1,
  SEARCH_ENGINE_CONDUIT,
  NULL,
  NULL,
  36,
};

const char* const array_delfi_lt_alternate_urls[] = {
  "http://www.delfi.lt/paieska/?q={searchTerms}",
};
const PrepopulatedEngine delfi_lt = {
  u"DELFI",
  u"delfi.lt",
  "https://www.delfi.lt/favicon.ico",
  "https://www.delfi.lt/paieska/?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_delfi_lt_alternate_urls,
  1,
  SEARCH_ENGINE_DELFI,
  NULL,
  NULL,
  45,
};

const PrepopulatedEngine delfi_lv = {
  u"DELFI",
  u"delfi.lv",
  "http://g1.delphi.lv/favicon.ico",
  "http://www.delfi.lv/search_all/?ie={inputEncoding}&q={searchTerms}&lang={language}&cx=partner-pub-7754285690273419%3A1507605038&cof=FORID%3A10",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_DELFI,
  NULL,
  NULL,
  45,
};

const char* const array_delta_alternate_urls[] = {
  "http://www.delta-search.com/?q={searchTerms}",
  "http://www1.delta-search.com/home?q={searchTerms}",
  "http://www1.delta-search.com/?q={searchTerms}",
  "http://www2.delta-search.com/home?q={searchTerms}",
  "http://www2.delta-search.com/?q={searchTerms}",
  "http://www.search.delta-search.com/home?q={searchTerms}",
  "http://www.search.delta-search.com/?q={searchTerms}",
  "http://www.yhs.delta-search.com/home?q={searchTerms}",
  "http://www.yhs.delta-search.com/?q={searchTerms}",
  "http://mixidj.delta-search.com/home?q={searchTerms}",
  "http://mixidj.delta-search.com/?q={searchTerms}",
  "http://www.search.delta-search.com/home?q={searchTerms}",
  "http://www.search.delta-search.com/?q={searchTerms}",
};
const PrepopulatedEngine delta = {
  u"Delta",
  u"delta-search.com",
  "http://www.delta-search.com/favicon.ico",
  "http://www.delta-search.com/home?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_delta_alternate_urls,
  13,
  SEARCH_ENGINE_DELTA,
  NULL,
  NULL,
  66,
};

const PrepopulatedEngine funmoods = {
  u"Funmoods",
  u"searchfunmoods.com",
  "http://searchfunmoods.com/favicon.ico",
  "http://searchfunmoods.com/results.php?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_FUNMOODS,
  NULL,
  NULL,
  60,
};

const PrepopulatedEngine givero = {
  u"Givero",
  u"givero.com",
  "https://www.givero.com/favicon.ico",
  "https://www.givero.com/search?q={searchTerms}",
  "UTF-8",
  "https://www.givero.com/suggest?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GIVERO,
  NULL,
  NULL,
  95,
};

const PrepopulatedEngine gmx = {
  u"GMX Search",
  u"search.gmx.com",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://search.gmx.com/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.com/s?q={searchTerms}&brand=gmxcom&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const PrepopulatedEngine gmx_at = {
  u"GMX Suche",
  u"suche.gmx.at",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://suche.gmx.at/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.at/s?q={searchTerms}&brand=gmxat&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const PrepopulatedEngine gmx_de = {
  u"GMX Suche",
  u"suche.gmx.net",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://suche.gmx.net/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.net/s?q={searchTerms}&brand=gmx&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const PrepopulatedEngine gmx_es = {
  u"GMX Search",
  u"search.gmx.es",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://search.gmx.es/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.es/s?q={searchTerms}&brand=gmxes&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const PrepopulatedEngine gmx_fr = {
  u"GMX Search",
  u"search.gmx.fr",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://search.gmx.fr/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.fr/s?q={searchTerms}&brand=gmxfr&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const PrepopulatedEngine gmx_gb = {
  u"GMX Search",
  u"search.gmx.co.uk",
  "https://dl.gmx.com/apps/favicon.ico",
  "https://search.gmx.co.uk/web/result?q={searchTerms}&sp=b",
  "UTF-8",
  "https://suggestplugin.gmx.co.uk/s?q={searchTerms}&brand=gmxcouk&enc={inputEncoding}&sp=b",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_GMX,
  NULL,
  NULL,
  96,
};

const char* const array_goo_alternate_urls[] = {
  "http://search.goo.ne.jp/web.jsp?MT={searchTerms}&IE={inputEncoding}",
  "http://search.goo.ne.jp/sgt.jsp?MT={searchTerms}&CL=plugin&FM=json&IE={inputEncoding}",
};
const PrepopulatedEngine goo = {
  u"goo",
  u"search.goo.ne.jp",
  "https://search.goo.ne.jp/cdn/common/img/favicon.ico",
  "https://search.goo.ne.jp/web.jsp?MT={searchTerms}&IE={inputEncoding}",
  "EUC-JP",
  "https://search.goo.ne.jp/sgt.jsp?MT={searchTerms}&CL=plugin&FM=json&IE={inputEncoding}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_goo_alternate_urls,
  2,
  SEARCH_ENGINE_GOO,
  NULL,
  NULL,
  23,
};

const PrepopulatedEngine imesh = {
  u"IMesh",
  u"search.imesh.net",
  "http://search.imesh.net/favicon.ico",
  "http://search.imesh.net/music?hl={language}&si={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_IMESH,
  NULL,
  NULL,
  81,
};

const char* const array_iminent_alternate_urls[] = {
  "http://search.iminent.com/SearchTheWeb/v6/1033/homepage/Default.aspx#q={searchTerms}",
  "http://search.iminent.com/SearchTheWeb/v6/1033/homepage/Result.aspx#q={searchTerms}",
  "http://start.iminent.com/?q={searchTerms}",
  "http://start.iminent.com/StartWeb/1033/homepage/#q={searchTerms}",
};
const PrepopulatedEngine iminent = {
  u"SearchTheWeb",
  u"iminent.com",
  "http://search.iminent.com/Shared/Images/favicon_gl.ico",
  "http://search.iminent.com/?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_iminent_alternate_urls,
  4,
  SEARCH_ENGINE_IMINENT,
  NULL,
  NULL,
  79,
};

const PrepopulatedEngine in = {
  u"in.gr",
  u"in.gr",
  "http://find.in.gr/Themes/1/Default/Media/Layout/icon_in.png",
  "http://find.in.gr/?q={searchTerms}&ie={inputEncoding}&cx=partner-pub-3451081775397713%3Aklnvxp4nycj&cof=FORID%3A9",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_IN,
  NULL,
  NULL,
  54,
};

const char* const array_incredibar_alternate_urls[] = {
  "http://search.incredibar.com/?q={searchTerms}",
  "http://mystart.incredibar.com/?search={searchTerms}",
};
const PrepopulatedEngine incredibar = {
  u"MyStart",
  u"mystart.incredibar.com",
  "http://search.incredibar.com/favicon.ico",
  "http://search.incredibar.com/search.php?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_incredibar_alternate_urls,
  2,
  SEARCH_ENGINE_INCREDIBAR,
  NULL,
  NULL,
  74,
};

const PrepopulatedEngine info_com = {
  u"Info.com",
  u"info.com",
  "https://www.info.com/static/www.info.com/favicon.ico",
  "https://www.info.com/serp?q={searchTerms}&segment=info.0472",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_INFO_COM,
  NULL,
  NULL,
  97,
};

const PrepopulatedEngine libero = {
  u"Libero",
  u"libero.it",
  "http://ms1.iol.it/graph_hf/v.8.3.04/themes/default/img/favicon.ico",
  "http://arianna.libero.it/search/abin/integrata.cgi?query={searchTerms}",
  "ISO-8859-1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_LIBERO,
  NULL,
  NULL,
  63,
};

const PrepopulatedEngine metager_de = {
  u"MetaGer",
  u"metager.de",
  "https://metager.de/favicon.ico",
  "https://metager.de/meta/meta.ger3?eingabe={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_METAGER,
  NULL,
  NULL,
  98,
};

const PrepopulatedEngine metager_gb = {
  u"MetaGer",
  u"metager.org",
  "https://metager.de/favicon.ico",
  "https://metager.org/meta/meta.ger3?eingabe={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_METAGER,
  NULL,
  NULL,
  98,
};

const char* const array_neti_alternate_urls[] = {
  "https://www.neti.ee/cgi-bin/otsing?query={searchTerms}&src=web",
  "https://www.neti.ee/api/suggestOS?suggestVersion=1&suggestQuery={searchTerms}",
};
const PrepopulatedEngine neti = {
  u"NETI",
  u"neti.ee",
  "http://www.neti.ee/favicon.ico",
  "http://www.neti.ee/cgi-bin/otsing?query={searchTerms}",
  "ISO-8859-1",
  "http://www.neti.ee/api/suggestOS?suggestQuery={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_neti_alternate_urls,
  2,
  SEARCH_ENGINE_NETI,
  NULL,
  NULL,
  44,
};

const PrepopulatedEngine nigma = {
  u"\x041d" u"\x0438" u"\x0433" u"\x043c" u"\x0430" u"",
  u"nigma.ru",
  "http://nigma.ru/themes/nigma/img/favicon.ico",
  "http://nigma.ru/?s={searchTerms}",
  "UTF-8",
  "http://autocomplete.nigma.ru/complete/query_help.php?suggest=true&q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_NIGMA,
  NULL,
  NULL,
  43,
};

const PrepopulatedEngine oceanhero = {
  u"OceanHero",
  u"oceanhero.today",
  "https://oceanhero.today/favicon.ico",
  "https://oceanhero.today/web?q={searchTerms}",
  "UTF-8",
  "https://api.oceanhero.today/suggestions?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_OCEANHERO,
  NULL,
  NULL,
  99,
};

const PrepopulatedEngine ok = {
  u"OK.hu",
  u"ok.hu",
  "http://ok.hu/gfx/favicon.ico",
  "http://ok.hu/katalogus?q={searchTerms}",
  "ISO-8859-2",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_OK,
  NULL,
  NULL,
  6,
};

const PrepopulatedEngine privacywall = {
  u"PrivacyWall",
  u"privacywall.org",
  "https://www.privacywall.org/images/favicon_32x32.ico",
  "https://www.privacywall.org/search/secure/?q={searchTerms}",
  "UTF-8",
  "https://search.privacywall.org/suggest.php?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_PRIVACYWALL,
  NULL,
  NULL,
  100,
};

const char* const array_rambler_alternate_urls[] = {
  "https://nova.rambler.ru/search?query={searchTerms}",
  "https://nova.rambler.ru/suggest?v=3&query={searchTerms}",
};
const PrepopulatedEngine rambler = {
  u"\x0420" u"\x0430" u"\x043c" u"\x0431" u"\x043b" u"\x0435" u"\x0440" u"",
  u"rambler.ru",
  "http://i.rl0.ru/2011/icons/rambler.ico",
  "http://nova.rambler.ru/search?query={searchTerms}",
  "UTF-8",
  "http://nova.rambler.ru/suggest?v=3&query={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_rambler_alternate_urls,
  2,
  SEARCH_ENGINE_RAMBLER,
  NULL,
  NULL,
  16,
};

const PrepopulatedEngine sapo = {
  u"SAPO",
  u"sapo.pt",
  "http://imgs.sapo.pt/images/sapo.ico",
  "http://pesquisa.sapo.pt/?q={searchTerms}",
  "UTF-8",
  "http://pesquisa.sapo.pt/livesapo?q={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_SAPO,
  NULL,
  NULL,
  77,
};

const PrepopulatedEngine searchnu = {
  u"searchnu",
  u"searchnu.com",
  "http://www.searchnu.com/favicon.ico",
  "http://www.searchnu.com/web?hl={language}&si={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_SEARCHNU,
  NULL,
  NULL,
  61,
};

const char* const array_search_results_alternate_urls[] = {
  "http://www.search-results.com/web?q={searchTerms}",
};
const PrepopulatedEngine search_results = {
  u"Search-results",
  u"search-results.com",
  "http://ak.apnstatic.com/media/images/favicon_search-results.ico",
  "http://dts.search-results.com/sr?lng={language}&src=hmp&q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_search_results_alternate_urls,
  1,
  SEARCH_ENGINE_SEARCH_RESULTS,
  NULL,
  NULL,
  78,
};

const char* const array_snapdo_alternate_urls[] = {
  "http://search.snap.do/?q={searchTerms}",
  "http://feed.snapdo.com/?q={searchTerms}",
  "http://feed.snap.do/?q={searchTerms}",
};
const PrepopulatedEngine snapdo = {
  u"SnapDo",
  u"search.snapdo.com",
  "http://linkurystoragenorthus.blob.core.windows.net/static/favicon.ico",
  "http://search.snapdo.com/?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_snapdo_alternate_urls,
  3,
  SEARCH_ENGINE_SNAPDO,
  NULL,
  NULL,
  70,
};

const char* const array_softonic_alternate_urls[] = {
  "http://en.softonic.com/s/{searchTerms}",
  "http://www.softonic.com/s/{searchTerms}",
  "http://www.softonic.com.br/s/{searchTerms}",
  "http://buscador.softonic.com/?q={searchTerms}",
  "http://nl.softonic.com/s/{searchTerms}",
  "https://search.softonic.com/?q={searchTerms}",
  "https://en.softonic.com/s/{searchTerms}",
  "https://www.softonic.com/s/{searchTerms}",
  "https://www.softonic.com.br/s/{searchTerms}",
  "https://buscador.softonic.com/?q={searchTerms}",
  "https://nl.softonic.com/s/{searchTerms}",
};
const PrepopulatedEngine softonic = {
  u"softonic",
  u"search.softonic.com",
  "http://search.softonic.com/img/favicon.ico",
  "http://search.softonic.com/?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_softonic_alternate_urls,
  11,
  SEARCH_ENGINE_SOFTONIC,
  NULL,
  NULL,
  80,
};

const PrepopulatedEngine sweetim = {
  u"SweetIM",
  u"home.sweetim.com",
  "http://search.sweetim.com/favicon.ico",
  "http://search.sweetim.com/search.asp?q={searchTerms}&ln={language}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_SWEETPACKS,
  NULL,
  NULL,
  65,
};

const char* const array_sweetpacks_alternate_urls[] = {
  "http://start.sweetpacks.com/?q={searchTerms}",
  "http://mysearch.sweetpacks.com/?q={searchTerms}",
};
const PrepopulatedEngine sweetpacks = {
  u"Sweetpacks",
  u"start.sweetpacks.com",
  "http://start.sweetpacks.com/favicon.ico",
  "http://start.sweetpacks.com/search.asp?q={searchTerms}&ln={language}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_sweetpacks_alternate_urls,
  2,
  SEARCH_ENGINE_SWEETPACKS,
  NULL,
  NULL,
  65,
};

const char* const array_terra_ar_alternate_urls[] = {
  "https://buscador.terra.com.ar/Default.aspx?source=Search&ca=s&query={searchTerms}",
};
const PrepopulatedEngine terra_ar = {
  u"Terra Argentina",
  u"terra.com.ar",
  "http://buscar.terra.com.ar/favicon.ico",
  "http://buscar.terra.com.ar/Default.aspx?source=Search&ca=s&query={searchTerms}",
  "ISO-8859-1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_terra_ar_alternate_urls,
  1,
  SEARCH_ENGINE_TERRA,
  NULL,
  NULL,
  90,
};

const char* const array_terra_es_alternate_urls[] = {
  "https://buscador.terra.es/Default.aspx?source=Search&ca=s&query={searchTerms}",
};
const PrepopulatedEngine terra_es = {
  u"Terra",
  u"terra.es",
  "http://buscador.terra.es/favicon.ico",
  "http://buscador.terra.es/Default.aspx?source=Search&ca=s&query={searchTerms}",
  "ISO-8859-1",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_terra_es_alternate_urls,
  1,
  SEARCH_ENGINE_TERRA,
  NULL,
  NULL,
  90,
};

const PrepopulatedEngine tut = {
  u"TUT.BY",
  u"tut.by",
  "http://search.tut.by/favicon.ico",
  "http://search.tut.by/?ru=1&query={searchTerms}",
  "UTF-8",
  "http://suggest.yandex.ru/suggest-ff.cgi?part={searchTerms}&limit=10",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_TUT,
  NULL,
  NULL,
  17,
};

const char* const array_walla_alternate_urls[] = {
  "https://search.walla.co.il/?q={searchTerms}",
};
const PrepopulatedEngine walla = {
  u"\x05d5" u"\x05d5" u"\x05d0" u"\x05dc" u"\x05d4" u"!",
  u"walla.co.il",
  "http://www.walla.co.il/favicon.ico",
  "http://search.walla.co.il/?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_walla_alternate_urls,
  1,
  SEARCH_ENGINE_WALLA,
  NULL,
  NULL,
  55,
};

const PrepopulatedEngine wp = {
  u"Wirtualna Polska",
  u"wp.pl",
  "http://i.wp.pl/a/i/stg/500/favicon.ico",
  "http://szukaj.wp.pl/szukaj.html?q={searchTerms}",
  "UTF-8",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_WP,
  NULL,
  NULL,
  76,
};

const PrepopulatedEngine yahoo_qc = {
  u"Yahoo! Qu\x00e9" u"bec",
  u"qc.yahoo.com",
  "https://qc.search.yahoo.com/favicon.ico",
  "https://qc.search.yahoo.com/search{google:pathWildcard}?ei={inputEncoding}&fr=crmas&p={searchTerms}",
  "UTF-8",
  "https://qc.search.yahoo.com/sugg/chrome?output=fxjson&appid=crmas&command={searchTerms}",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  NULL,
  0,
  SEARCH_ENGINE_YAHOO,
  NULL,
  NULL,
  2,
};

const char* const array_zoznam_alternate_urls[] = {
  "http://www.zoznam.sk/hladaj.fcgi?s={searchTerms}",
};
const PrepopulatedEngine zoznam = {
  u"Zoznam",
  u"zoznam.sk",
  "https://www.zoznam.sk/favicon.ico",
  "https://www.zoznam.sk/hladaj.fcgi?s={searchTerms}",
  "windows-1250",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  0,
  array_zoznam_alternate_urls,
  1,
  SEARCH_ENGINE_ZOZNAM,
  NULL,
  NULL,
  85,
};

const PrepopulatedEngine* const kAllEngines[] = {
	&ask,
	&baidu,
	&bing,
	&brave,
	&coccoc,
	&daum,
	&duckduckgo,
	&ecosia,
	&google,
	&karma,
	&lilo,
	&mail_ru,
	&mojeek,
	&naver,
	&nona,
	&panda,
	&petal_search,
	&presearch,
	&quendu,
	&qwant,
	&seznam_cz,
	&seznam_sk,
	&so_360,
	&sogou,
	&yahoo,
	&yahoo_ar,
	&yahoo_at,
	&yahoo_au,
	&yahoo_br,
	&yahoo_ca,
	&yahoo_ch,
	&yahoo_cl,
	&yahoo_co,
	&yahoo_de,
	&yahoo_dk,
	&yahoo_es,
	&yahoo_fi,
	&yahoo_fr,
	&yahoo_hk,
	&yahoo_id,
	&yahoo_in,
	&yahoo_it,
	&yahoo_jp,
	&yahoo_mx,
	&yahoo_my,
	&yahoo_nl,
	&yahoo_nz,
	&yahoo_pe,
	&yahoo_ph,
	&yahoo_se,
	&yahoo_sg,
	&yahoo_th,
	&yahoo_tr,
	&yahoo_tw,
	&yahoo_uk,
	&yahoo_ve,
	&yahoo_vn,
	&yandex_by,
	&yandex_com,
	&yandex_kz,
	&yandex_ru,
	&yandex_tr,
	&yandex_ua,
	&yep,
	&you,
	&atlas_cz,
	&atlas_sk,
	&avg,
	&babylon,
	&conduit,
	&delfi_lt,
	&delfi_lv,
	&delta,
	&funmoods,
	&givero,
	&gmx,
	&gmx_at,
	&gmx_de,
	&gmx_es,
	&gmx_fr,
	&gmx_gb,
	&goo,
	&imesh,
	&iminent,
	&in,
	&incredibar,
	&info_com,
	&libero,
	&metager_de,
	&metager_gb,
	&neti,
	&nigma,
	&oceanhero,
	&ok,
	&privacywall,
	&rambler,
	&sapo,
	&searchnu,
	&search_results,
	&snapdo,
	&softonic,
	&sweetim,
	&sweetpacks,
	&terra_ar,
	&terra_es,
	&tut,
	&walla,
	&wp,
	&yahoo_qc,
	&zoznam,
};
const size_t kAllEnginesLength = 110;

}  // namespace TemplateURLPrepopulateData
